unit zahl2txt;

{

Converts a Number to Plain Text (German)

Konvertiert eine Zahl in deutschen Klartext

z.B. zum Beschriften von Zahlkarten oder Schecks

Version: 1.0
Copyright 1998-99 Andreas Schmidt and friends

Freeware

for use with Delphi 2/3/4

bug-reports, enhancements:
mailto:shmia@bizerba.de or a_j_schmidt@rocketmail.com

get latest version from
http://members.tripod.de/AJSchmidt/index.html


Ich bin nicht dafr verantwortlich wenn
auf einer Zahlkarte 'sechsundreissigmillionen' steht obwohl
nur 3,60 DM drauf sein sollten.  :-)


Falls Ihr meine Funktion verwendet, denkt auch an mich
und schickt mir auch mal ein Stckchen Source-Code.


To Do:
falls jemand Lust hat, bitte auf Delphi 1 umbauen und mir
den Sourcecode schicken.

}


interface



function IntegerToKlartext(i : integer):string;

implementation

const numNamesA:array[1..17] of string =
	(
	('ein'),
	('zwei'),
	('drei'),
	('vier'),
	('fnf'),
	('sechs'),
	('sieben'),
	('acht'),
	('neun'),
	('zehn'),
	('elf'),
	('zwlf'),
	('dreizehn'),
	('vierzehn'),
	('fnfzehn'),
	('sechzehn'),
	('siebzehn')
	);



const numNamesB:array[1..9] of string =
	(
	('zehn'),
	('zwanzig'),
	('dreissig'),
	('vierzig'),
	('fnfzig'),
	('sechzig'),
	('siebzig'),
	('achtzig'),
	('neunzig')
	);

const hundert:string = 'hundert';
const tausend = 'tausend';
const und = 'und';
const million = 'million';




function convNummer(i : integer):string;
var
	j : integer;
begin
	if i = 0 then
		Result := ''
	else if i < 17 then
		Result := numNamesA[i]
	else if i < 20 then
		Result := numNamesA[i mod 10] + numNamesB[1]
	else if i < 100 then
	begin
		if (i mod 10) = 0 then
			Result := numNamesB[i div 10]
		else
			Result := numNamesA[i mod 10] + und + numNamesB[i div 10];
	end
	else if i < 1000 then
		Result := convNummer(i div 100) + hundert + convNummer(i mod 100)
	else if i < 1000000 then
		Result := convNummer(i div 1000) + tausend + convNummer(i mod 1000)
	else
	begin
		j:= i div 1000000;

		if j = 1 then
			Result := 'eine'
		else
			 Result := convNummer(j);
		Result := Result + million;
		if j > 1 then
			Result := Result +'en';
		Result := Result + convNummer(i mod 1000000);
	end;
end;


function IntegerToKlartext(i : integer):string;
begin
	if i < 0 then
		Result := 'minus ' + IntegerToKlartext(-i)
	else if i = 0 then
		Result := 'null'
	else if i = 1 then
		Result := 'eins'
	else
		Result := convNummer(i);
end;


end.
